searchData={"items":[{"type":"module","title":"DomHelpers","doc":"Just `use DomHelpers` to import all the methods.\n\nFor more information about accessor helpers, see `DomHelpers.Accessors`.\n\nFor more information about selection helpers, see `DomHelpers.Selectors`.","ref":"DomHelpers.html"},{"type":"module","title":"DomHelpers.Accessors","doc":"Collection of methods to simplify the access to different parts of the DOM.","ref":"DomHelpers.Accessors.html"},{"type":"function","title":"DomHelpers.Accessors.attribute/2","doc":"Retrieve the values of the given attribute in the given fragment.","ref":"DomHelpers.Accessors.html#attribute/2"},{"type":"function","title":"Examples - DomHelpers.Accessors.attribute/2","doc":"```\niex> find(~s(  First  Second  Third  ), \"li\") |> attribute(\"class\")\n~w(odd even odd)\n\niex> find(~s(  First  Second  Third  ), \"li\") |> attribute(\"data-test\")\n~w(first second third)\n\niex> find(~s(  First  Second  Third  ), \".even\") |> attribute(\"data-test\")\n~w(second)","ref":"DomHelpers.Accessors.html#attribute/2-examples"},{"type":"function","title":"DomHelpers.Accessors.attribute/3","doc":"Behaves like `attribute/2` but uses the second argument as selector.","ref":"DomHelpers.Accessors.html#attribute/3"},{"type":"function","title":"Examples - DomHelpers.Accessors.attribute/3","doc":"```\niex> attribute(~s(  First  Second  Third  ), \"li\", \"class\")\n~w(odd even odd)\n\niex> attribute(~s(  First  Second  Third  ), \"li\", \"data-test\")\n~w(first second third)\n\niex> attribute(~s(  First  Second  Third  ), \".even\", \"data-test\")\n~w(second)\n```","ref":"DomHelpers.Accessors.html#attribute/3-examples"},{"type":"function","title":"DomHelpers.Accessors.classes/1","doc":"Return a list of the classes of the current fragment.","ref":"DomHelpers.Accessors.html#classes/1"},{"type":"function","title":"Examples - DomHelpers.Accessors.classes/1","doc":"```\niex> classes(~s( Hello ))\n~w(some classes here)\n\niex> classes(~s( Hello ))","ref":"DomHelpers.Accessors.html#classes/1-examples"},{"type":"function","title":"DomHelpers.Accessors.classes/2","doc":"Return a list with the list of classes of all the elements that satisfy the selector\nin the given fragment.","ref":"DomHelpers.Accessors.html#classes/2"},{"type":"function","title":"Example - DomHelpers.Accessors.classes/2","doc":"```\niex> classes(~s(  First  Second  Third  ), \".odd\")\n[[\"odd\"], [\"odd\"]]\n\niex> classes(~s(  First  Second  Third  ), \"li\")\n[[\"odd\"], [\"even\"], [\"odd\"]]\n```","ref":"DomHelpers.Accessors.html#classes/2-example"},{"type":"function","title":"DomHelpers.Accessors.find/2","doc":"Finds all the nodes in the htmlable that satisfy the selector.","ref":"DomHelpers.Accessors.html#find/2"},{"type":"function","title":"Examples - DomHelpers.Accessors.find/2","doc":"```\niex> find(~s(  First  Second  Third  ), \".odd\")\n[{\"li\", [{\"class\", \"odd\"}], [\"First\"]}, {\"li\", [{\"class\", \"odd\"}], [\"Third\"]}]\n\niex> find(~s(  First  Second  Third  ), \".even\")\n[{\"li\", [{\"class\", \"even\"}], [\"Second\"]}]\n\niex> find(~s(  First  Second  Third  ), \".none\")\n[]\n\niex> find(~s(  First  Second  Third  ), \"li\")\n[{\"li\", [{\"class\", \"odd\"}], [\"First\"]}, {\"li\", [{\"class\", \"even\"}], [\"Second\"]}, {\"li\", [{\"class\", \"odd\"}], [\"Third\"]}]\n```","ref":"DomHelpers.Accessors.html#find/2-examples"},{"type":"function","title":"DomHelpers.Accessors.find_count/2","doc":"Returns the number of elements that satisfy the given selector.","ref":"DomHelpers.Accessors.html#find_count/2"},{"type":"function","title":"Examples - DomHelpers.Accessors.find_count/2","doc":"```\niex> find_count(~s(  First  Second  Third  ), \".odd\")\n2\n\niex> find_count(~s(  First  Second  Third  ), \".even\")\n1\n\niex> find_count(~s(  First  Second  Third  ), \".none\")\n0\n\niex> find_count(~s(  First  Second  Third  ), \"li\")\n3\n```","ref":"DomHelpers.Accessors.html#find_count/2-examples"},{"type":"function","title":"DomHelpers.Accessors.find_first/2","doc":"Like `find/2` but gets the first instance.","ref":"DomHelpers.Accessors.html#find_first/2"},{"type":"function","title":"Examples - DomHelpers.Accessors.find_first/2","doc":"```\niex> find_first(~s(  First  Second  Third  ), \".odd\")\n{\"li\", [{\"class\", \"odd\"}], [\"First\"]}\n\niex> find_first(~s(  First  Second  Third  ), \".even\")\n{\"li\", [{\"class\", \"even\"}], [\"Second\"]}\n\niex> find_first(~s(  First  Second  Third  ), \".none\")\nnil\n\niex> find_first(~s(  First  Second  Third  ), \"li\")\n{\"li\", [{\"class\", \"odd\"}], [\"First\"]}\n```","ref":"DomHelpers.Accessors.html#find_first/2-examples"},{"type":"function","title":"DomHelpers.Accessors.text/3","doc":"Returns the whole text inside the html fragment passed in. Spaces are normalised (meaning that if there are multiple\nspaces together they are reduced to just one and the text is trimmed on both ends).\n\nFirst arguments is an htmlable (see `DomHelpers.Htmlable`), second can either be a selector or options. If a selector\nis passed in, `find/2` will be used to locate matching elements before getting the text. In case a selector is given,\na third optional argument with options can be passed in.\n\nOptions to `Floki.text/2` can be passed inside the `:text` key in the options.","ref":"DomHelpers.Accessors.html#text/3"},{"type":"function","title":"Examples - DomHelpers.Accessors.text/3","doc":"```\niex> text(~s(   First     Second     Third   ), \".odd\")\n\"First Third\"\n\niex> text(~s(   First     Second     Third   ), \".even\")\n\"Second\"\n\niex> text(~s(   First     Second     Third   ), \".none\")\n\"\"\n\niex> text(~s(   First     Second     Third   ), \"li\")\n\"First Second Third\"\n\niex> find(~s(   First     Second     Third   ), \"li\") |> Enum.map(&text/1)\n~w(First Second Third)\n```","ref":"DomHelpers.Accessors.html#text/3-examples"},{"type":"protocol","title":"DomHelpers.Htmlable","doc":"Implements conversion from anything to something Floki can parse.","ref":"DomHelpers.Htmlable.html"},{"type":"function","title":"DomHelpers.Htmlable.to_html/1","doc":"Convert the given input to a parseable HTML fragment.","ref":"DomHelpers.Htmlable.html#to_html/1"},{"type":"type","title":"DomHelpers.Htmlable.t/0","doc":"All the types that implement this protocol.","ref":"DomHelpers.Htmlable.html#t:t/0"},{"type":"module","title":"DomHelpers.Selectors","doc":"Collection of methods to simplify the creation of complex selectors.","ref":"DomHelpers.Selectors.html"},{"type":"function","title":"DomHelpers.Selectors.with_attr/2","doc":"Complements the selector by checking that the attribute is present.","ref":"DomHelpers.Selectors.html#with_attr/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_attr/2","doc":"```\niex> with_attr(\"input\", \"checked\")\n~s/input[\"checked\"]/\n```","ref":"DomHelpers.Selectors.html#with_attr/2-examples"},{"type":"function","title":"DomHelpers.Selectors.with_attr/3","doc":"Complements the selector by checking that the attribute has the given value.\n\nValue can either be a value or a tuple `{matcher_name, value}` where `matcher_name`\ncan be one of:\n\n- `:contains_word` for `~=`.\n- `:contains` for `*=`.\n- `:equal` for `=`.\n- `:ends_with` for `$=`.\n- `:starts_with` for `^=`.\n- `:subcode` for `|=`.\n\nFor more information on these selectors, please check [MDN](https://developer.mozilla.org/en-US/docs/Web/CSS/Attribute_selectors).","ref":"DomHelpers.Selectors.html#with_attr/3"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_attr/3","doc":"```\niex> with_attr(\"input\", \"type\", \"text\")\n~s/input[\"type\"=\"text\"]/\n\niex> with_attr(\"input\", \"class\", {:contains_word, \"hidden\"})\n~s/input[\"class\"~=\"hidden\"]/\n\niex> with_attr(\"input\", \"type\", {:equal, \"text\"})\n~s/input[\"type\"=\"text\"]/\n\niex> with_attr(\"div\", \"data-test\", {:ends_with, \"editor\"})\n~s/div[\"data-test\"$=\"editor\"]/\n\niex> with_attr(\"div\", \"data-test\", {:starts_with, \"editor\"})\n~s/div[\"data-test\"^=\"editor\"]/\n\niex> with_attr(\"main\", \"lang\", {:subcode, \"es\"})\n~s/main[\"lang\"|=\"es\"]/\n```","ref":"DomHelpers.Selectors.html#with_attr/3-examples"},{"type":"function","title":"DomHelpers.Selectors.with_attrs/2","doc":"Like `with_attr/2` but several attributes can be passed at once.\n\nAttributes can be passed as a map or keywords. In both cases, keys are the names\nof the attributes, while the keys can be:\n\n- `true` for just checking that the attribute is present.\n- `false` for checking that the attribute is not present.\n- Any other value would be passed directly as attribute value to `with_attr/3`. Check\n  its documentation for all the options.","ref":"DomHelpers.Selectors.html#with_attrs/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_attrs/2","doc":"```\niex> with_attrs(\"input\", type: \"checkbox\", checked: true)\n~s/input[\"type\"=\"checkbox\"][\"checked\"]/\n\niex> with_attrs(\"input\", name: false, class: {:contains_word, \"hola\"}, \"data-test\": false)\n~s/input[\"class\"~=\"hola\"]:not([\"name\"]):not([\"data-test\"])/\n```","ref":"DomHelpers.Selectors.html#with_attrs/2-examples"},{"type":"function","title":"DomHelpers.Selectors.with_class/2","doc":"Add the class selector to the given one.","ref":"DomHelpers.Selectors.html#with_class/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_class/2","doc":"```\niex> with_class(\"div\", \"hidden\")\n\"div.hidden\"\n\niex> with_class(\"span\", \"flex\")\n\"span.flex\"\n```","ref":"DomHelpers.Selectors.html#with_class/2-examples"},{"type":"function","title":"DomHelpers.Selectors.with_classes/2","doc":"Checks if the selector contains the given classes.","ref":"DomHelpers.Selectors.html#with_classes/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_classes/2","doc":"```\niex> with_classes(\"div\", ~w(flex mb-4))\n\"div.flex.mb-4\"\n\niex> with_classes(\"span\", ~w(p-1 m-2))\n\"span.p-1.m-2\"\n```","ref":"DomHelpers.Selectors.html#with_classes/2-examples"},{"type":"function","title":"DomHelpers.Selectors.with_id/2","doc":"Adds the given id to the selector passed in.","ref":"DomHelpers.Selectors.html#with_id/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.with_id/2","doc":"```\niex> with_id(\"main\", \"main_content\")\n\"main#main_content\"\n\niex> with_id(\"div\", \"modal\")\n\"div#modal\"\n```","ref":"DomHelpers.Selectors.html#with_id/2-examples"},{"type":"function","title":"DomHelpers.Selectors.without_attr/2","doc":"Complements the selector by checking that it does not have the given attribute.","ref":"DomHelpers.Selectors.html#without_attr/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.without_attr/2","doc":"```\niex> without_attr(\"input\", \"checked\")\n~s/input:not([\"checked\"])/\n```","ref":"DomHelpers.Selectors.html#without_attr/2-examples"},{"type":"function","title":"DomHelpers.Selectors.without_attr/3","doc":"Complements the selector by checking that it does not have the given attribute with the\ngiven value. Check `with_attr/3` for possible values.","ref":"DomHelpers.Selectors.html#without_attr/3"},{"type":"function","title":"Examples - DomHelpers.Selectors.without_attr/3","doc":"```\niex> without_attr(\"input\", \"type\", \"text\")\n~s/input:not([\"type\"=\"text\"])/\n\niex> without_attr(\"input\", \"class\", {:contains_word, \"hidden\"})\n~s/input:not([\"class\"~=\"hidden\"])/\n\niex> without_attr(\"input\", \"type\", {:equal, \"text\"})\n~s/input:not([\"type\"=\"text\"])/\n\niex> without_attr(\"div\", \"data-test\", {:ends_with, \"editor\"})\n~s/div:not([\"data-test\"$=\"editor\"])/\n\niex> without_attr(\"div\", \"data-test\", {:starts_with, \"editor\"})\n~s/div:not([\"data-test\"^=\"editor\"])/\n\niex> without_attr(\"main\", \"lang\", {:subcode, \"es\"})\n~s/main:not([\"lang\"|=\"es\"])/\n```","ref":"DomHelpers.Selectors.html#without_attr/3-examples"},{"type":"function","title":"DomHelpers.Selectors.without_class/2","doc":"Modifies the selector to check it does not have the given class.","ref":"DomHelpers.Selectors.html#without_class/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.without_class/2","doc":"```\niex> without_class(\"div\", \"hidden\")\n~s/div:not(.hidden)/\n```","ref":"DomHelpers.Selectors.html#without_class/2-examples"},{"type":"function","title":"DomHelpers.Selectors.without_classes/2","doc":"Modifies the selector to check it does not contain the given classes.","ref":"DomHelpers.Selectors.html#without_classes/2"},{"type":"function","title":"Examples - DomHelpers.Selectors.without_classes/2","doc":"```\niex> without_classes(\"div\", ~w(flex mb-4))\n~s/div:not(.flex):not(.mb-4)/\n```","ref":"DomHelpers.Selectors.html#without_classes/2-examples"},{"type":"extras","title":"Overview","doc":"# DomHelpers\n\n[![Module Version](https://img.shields.io/hexpm/v/dom_helpers.svg)](https://hex.pm/packages/dom_helpers)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/dom_helpers/)\n[![License](https://img.shields.io/hexpm/l/dom_helpers.svg)](https://github.com/Serabe/dom_helpers/blob/main/LICENSE.txt)\n\n`DomHelpers` is a collection of helpers for creating selectors and ways of accessing different parts of the dom.\n`DomHelpers` also accept as documents anything like `Phoenix.LiveViewTest.View`s, `Phoenix.LiveViewTest.Element`s or\n`Plug.Conn`s.\n\n`DomHelpers` is built on top of [`Floki`](https://github.com/philss/floki) to provide some sweet helpers for your tests.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"Add the following package to `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dom_helpers, \"~> 0.2.0\", only: [:dev, :test]}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Why? - Overview","doc":"#","ref":"readme.html#why"},{"type":"extras","title":"DomHelpers.Accessors - Overview","doc":"ExUnit does not have an API for implementing assertions with support for custom messages. That makes that when an assertion\nlike `has_element?/2` or `has_element?/3` fails, we get a huge error printing out either the view struct or the html passed\nin. Furthermore, the API for testing dead controllers and dead views are different. `find/2` can be used with views and elements\nin LiveView testing, with controllers when in a classic Phoenix app, and with any kind of html anywhere.\n\nFurthermore, `dom_helpers` encourage better testing practices (`=~` I'm looking at you) by providing easy ways to access\ndifferent part of the DOM. For example, `text/3` provides several pros over `has_element?/3` or `render(view) =~`:\n\n1. Easier debugging when a test fails. True story, the first problem I had while maintaining an app was that a formatted date\n   was not matching the expected output. In that same page there were over 8 different dates, and the matcher was\n   `render(view) =~ formatted_date`, so most of the time was figuring out which of the dates was supposed to match. While it might\n   be obvious for someone used to the codebase, new developers will struggle with this.\n2. Better error when failing. When `has_element?/3` fails, you get a dump of the whole struct or html and the other arguments.\n   When `text/3 == some_text` fails, you get a nice diff with the differences.\n3. Tests are easier to reason about. I've seen and experiences problems with tests that were testing things like dates, percentages,\n   numbers, etc. In these cases, having some assertion like `assert has_element?(view, date_selector, \"2nd Feb\")` can easily give false\n   positives, as `\"22nd Feb\"` will match without problem.\n\n#","ref":"readme.html#domhelpers-accessors"},{"type":"extras","title":"DomHelpers.Selectors - Overview","doc":"Selectors can get really complicated and hard to parse when reading. For example, reading:\n\n```elixir\nwith_attrs(\"input\", %{\n  checked: true,\n  type: \"checkbox\",\n  value: \"t\",\n  class: {:contains_word, \"primary\"},\n  name: {:ends_with, \"[remember_me]\"}\n})\n```\n\nis much easier than reading:\n\n```elixir\n~s/input[\"name\"$=\"[remember_me]\"][\"type\"=\"checkbox\"][\"value\"=\"t\"][\"checked\"][\"class\"~=\"primary\"]\n```\n\nor even:\n\n```elixir\n~s/input[name$=\"[remember_me]\"][type=checkbox][value=t][checked][class~=primary]\n```\n\nIt is more verbose, but the intent is clearer.\n\nThey are also chainable: you can easily create more complex selectors for your app based on these.\n\n```elixir\ninput_being_tested = \"input\" |> with_attrs(type: \"checkbox\", name: {:ends_with, \"[remember_me]\"}) |> without_class(\"secondary\")\n\nassert has_element?(view, with_attr(input_being_tested, :checked))\n\n# Some actions\n\nassert has_element?(view, without_attr(input_being_tested, :checked))\n```","ref":"readme.html#domhelpers-selectors"},{"type":"extras","title":"Usage - Overview","doc":"Just add `use DomHelpers` in your tests. It will import all helpers from the different modules.\nIf you are interested in more granular control, just manually `alias` or `import` each module.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Selectors - Overview","doc":"There are several helpers for constructing complex selectors in [`DomHelpers.Selectors`](https://hexdocs.pm/dom_helpers/DomHelpers.Selectors.html).\nThere are many interesting helpers, but please, take special attention to:\n\n- [`with_attr/3`](https://hexdocs.pm/dom_helpers/DomHelpers.Selectors.html#with_attr/3) and how you can provide values to use different matchers.\n- [`with_attrs/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Selectors.html#with_attrs/2) that lets you provide complex attribute selectors easily and in a readable way. It also handles some current caveats in Floki.\n\nYou can find some other helpers for dealing with classes and ids too.\n\nPlease, request extra helpers if you find anything you need.\n\n#","ref":"readme.html#selectors"},{"type":"extras","title":"Accessors - Overview","doc":"Currently, the following accessors are available in [`DomHelpers.Accessors`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html):\n\n- [`attribute/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#attribute/2) and [`attribute/3`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#attribute/3) lets you access attributes values by the attribute name.\n- [`classes/1`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#classes/2) and [`classes/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#classes/2) let you access the `class` attribute as a list of classes. If you want the full, unparsed string, use `attribute/2` or `attribute/3` instead.\n- [`find/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#find/2) let's you find all the elements that satisfy a given selector.\n- [`find_count/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#find_count/2) is pretty much syntactic sugar for `find(html, selector) |> length()`\n- [`find_first/2`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#find_first/2) is pretty much syntactic sugar for `find(html, selector) |> List.first()`. Frontend developers beware that while in JS we have `querySelector` and `querySelectorAll`, in `dom_helpers` by default all matching elements are returned.\n- [`text/3`](https://hexdocs.pm/dom_helpers/DomHelpers.Accessors.html#text/3) returns the text. Please, read the documentation for all the possibilities.\n\nFor more details on usage and some sweet examples, please refer to the linked documentation.\n\nPlease, request extra helpers if you find anything you need.","ref":"readme.html#accessors"}],"content_type":"text/markdown"}